Subject: Re: [babel] WG Last Call for draft-ietf-babel-source-specific (2018-03-26 to 2018-04-09)

From: Donald Eastlake <[email-masked]>
Date: Tue, 22 May 2018 11:52:04 -0400

This is a reminder that
https://tools.ietf.org/html/draft-ietf-babel-source-specific-03
is still in WG Last Call and should be considered to be so until the
Chairs announce a consensus as to whether the document is ready or
not. Thus far, in my opinion, there have been an insufficient number
of responses so please indicate whether you believe the document is
ready for publication or not or have any suggestions for change.

Thanks,
Donald
===============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 155 Beaver Street, Milford, MA 01757 USA
 [email-masked]

On Mon, Mar 26, 2018 at 2:16 PM, Donald Eastlake <[email-masked]> wrote:
> Hi,
>
> This message starts a two-week WG Last Call on
> draft-ietf-babel-source-specific-03.txt. Please review the draft and
> indicate whether you think it is ready for advancement. Comments
> welcome.
>
> Thanks,
> Donald
> ===============================
>  Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
>  155 Beaver Street, Milford, MA 01757 USA
>  [email-masked]

---

From: Denis Ovsienko <[email-masked]>
Date: Mon, 28 May 2018 00:28:58 +0100

---- On Tue, 22 May 2018 16:52:04 +0100 Donald Eastlake <[email-masked]> wrote ---- 
 > ready for publication or not or have any suggestions for change. 

I have studied the latest revision of the document and would like to provide some feedback on its editorial merits. My lack of experience with the implementation of this extension does not let me do a thorough proof-reading of the technical concept.

   Note that the route entry contains a source which itself contains a
   source prefix.  These are two very different concepts that should not
   be confused.

(Here it could be helpful to provide a reference that helps the reader get the difference right.)

   However, this extension is encoded using mandatory sub-TLVs,
   introduced in [BABEL], and therefore is not compatible with the older
   version of the Babel Routing Protocol [RFC6126].  Consequently, this
   extension MUST NOT be used with routers implementing RFC 6126,
   otherwise persistent routing loops may occur.

(It looks like the right moment to stop for a moment and think. Could anybody briefly remind why leaving the protocol version 2 in 6126-bis is considered better than bumping it up to 3?)

   Fields:

   Type      Set to 128 to indicate a Source Prefix sub-TLV.

   Length    The length of the body, exclusive of the Type and Length
             fields.

   Source Plen  The length of the advertised source prefix.  This MUST
             NOT be 0.

   Source Prefix  The source prefix being advertised.  This field's size
             is (Source Plen)/8 rounded upwards.

(Is it correct that the model in this specification treats 0/0 same as any other source prefix, it is just the encoding convention that 0/0 is always represented with the absence of the sub-TLV? If so, it could be helpful to acknowledge this point in the document for clarity.)

Please find below a patch for the XML source file with some trivial corrections.

--- draft-ietf-babel-source-specific-03.xml.orig	2018-05-27 23:21:17.055373767 +0100
+++ draft-ietf-babel-source-specific-03.xml	2018-05-27 23:58:33.402935740 +0100
@@ -55,7 +55,7 @@
 
 <t>The Babel routing protocol <xref target="BABEL"/> is a distance vector
 routing protocol for next-hop routing.  In next-hop routing, each node
-maintains a forwarding table which maps destination prefixes to next hops.
+maintains a forwarding table, which maps destination prefixes to next hops.
 The forwarding decision is a per-packet operation which depends on the
 destination address of the packets and on the entries of the forwarding
 table.  When a packet is about to be routed, its destination address is
@@ -102,9 +102,10 @@
 <section title="Specification of Requirements">
 
 <t>The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
-"SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
-document are to be interpreted as described in <xref
-target="RFC2119"/>.</t>
+"SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and
+"OPTIONAL" in this document are to be interpreted as described in
+BCP&nbsp;14 <xref target="RFC2119" /> <xref target="RFC8174" /> when, and
+only when, they appear in all capitals, as shown here.</t>
 
 </section>
 
@@ -229,7 +230,7 @@
 these messages to optionally carry a source prefix sub-TLV, as described
 in <xref target="protocol-encoding"/> below.  The sub-TLV is marked as
 mandatory, so that an unextended implementation will silently ignore the
-whole enclising TLV.  A node obeying this specification MUST NOT send
+whole enclosing TLV.  A node obeying this specification MUST NOT send
 a TLV with a zero-length source prefix: instead, it sends a TLV with no
 source prefix sub-TLV.  Conversely, an extended implementation MUST
 interpret an unextended TLV as carrying a source prefix of zero length.
@@ -288,7 +289,7 @@
 to 0 (a wildcard route request) SHOULD send a full routing table dump,
 including routes with a non-zero-length source prefix.  A node MUST NOT
 send a wildcard request that carries a source prefix, and a node receiving
-a wildcard request with a with a source prefix MUST silently ignore
+a wildcard request with a source prefix MUST silently ignore
 it.</t>
 
 </section>
@@ -377,7 +378,7 @@
 ]]></artwork></figure>
 
 <t>Fields:
-<list style="hanging" hangIndent="10">
+<list style="hanging" hangIndent="15">
 <t hangText="Type">Set to 128 to indicate a Source Prefix
 sub-TLV.</t>
 <t hangText="Length">The length of the body, exclusive of the Type and
@@ -392,7 +393,7 @@
 <t>The contents of the source prefix sub-TLV are interpreted according to
 the AE of the enclosing TLV.</t>
 
-<t>Note that this sub-TLV is a mandatory sub-TLV.  Threfore, as described
+<t>Note that this sub-TLV is a mandatory sub-TLV.  Therefore, as described
 in Section 4.4 of <xref target="BABEL"/>, the whole TLV MUST be ignored if
 that sub-TLV is not understood (or malformed).  Otherwise, routing loops
 may occur (see <xref target="loop"/>).</t>
@@ -439,7 +440,7 @@
 <section title="IANA Considerations">
 
 <t>IANA has allocated sub-TLV number 128 for the Source Prefix sub-TLV in
-the Babel Sub-TLV Numbers registry.</t>
+the Babel Sub-TLV Types registry.</t>
 
 </section>
 
@@ -475,6 +476,8 @@
 <seriesInfo name="DOI" value="10.17487/RFC2119"/>
 </reference>
 
+<?rfc include="reference.RFC.8174.xml"?>
+
 <reference anchor="BABEL"><front>
 <title>The Babel Routing Protocol</title>
 <author fullname="Juliusz Chroboczek" initials="J." surname="Chroboczek"/>

-- 
    Denis Ovsienko